//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.ObservableCommandTest.ObservableCommandTest
{
    
    
    /// <summary>
    /// Class that implements the IObservableCommandTest interface through SiLA2
    /// </summary>
    public partial class ObservableCommandTestClient : IObservableCommandTest
    {
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.observablecommandtest.v1.ObservableCommandTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public ObservableCommandTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// Count from 0 to N-1 and return the current number as intermediate response.
        /// </summary>
        /// <param name="n">Number to count to</param>
        /// <param name="delay">The delay for each iteration</param>
        public virtual Tecan.Sila2.IIntermediateObservableCommand<long, long> Count(long n, double delay)
        {
            CountRequestDto request = new CountRequestDto(n, delay, null);
            request.Validate();
            return _channel.ExecuteIntermediatesCommand<CountRequestDto, long, CountIntermediateDto, long, CountResponseDto>(_serviceName, "Count", request, ConvertCountIntermediate, ConvertCountResponse, ConvertCountException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of Count to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertCountException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        /// <summary>
        /// Unwraps the response of the CountIntermediate command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private long ConvertCountIntermediate(CountIntermediateDto value)
        {
            return value.CurrentIteration.Extract(_executionManager.DownloadBinaryStore);
        }
        
        /// <summary>
        /// Unwraps the response of the CountResponse command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private long ConvertCountResponse(CountResponseDto value)
        {
            return value.IterationResponse.Extract(_executionManager.DownloadBinaryStore);
        }
        
        /// <summary>
        /// Echo the given value after the specified delay. The command state must be "waiting" until the delay has passed.
        /// </summary>
        /// <param name="value">The value to echo</param>
        /// <param name="delay">The delay before the command execution starts</param>
        public virtual Tecan.Sila2.IObservableCommand<long> EchoValueAfterDelay(long value, double delay)
        {
            EchoValueAfterDelayRequestDto request = new EchoValueAfterDelayRequestDto(value, delay, null);
            request.Validate();
            return _channel.ExecuteObservableCommand<EchoValueAfterDelayRequestDto, long, EchoValueAfterDelayResponseDto>(_serviceName, "EchoValueAfterDelay", request, ConvertEchoValueAfterDelayResponse, ConvertEchoValueAfterDelayException, _executionManager.CreateCallOptions(request.CommandIdentifier));
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of EchoValueAfterDelay to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertEchoValueAfterDelayException(string errorIdentifier, string errorMessage)
        {
            return null;
        }
        
        /// <summary>
        /// Unwraps the response of the EchoValueAfterDelayResponse command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private long ConvertEchoValueAfterDelayResponse(EchoValueAfterDelayResponseDto value)
        {
            return value.ReceivedValue.Extract(_executionManager.DownloadBinaryStore);
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Observable Command Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ObservableCommandTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/ObservableCommandTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IObservableCommandTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new ObservableCommandTestClient(channel, executionManager);
        }
    }
}

